#!/usr/bin/perl
#
#  $Id: closed1.pl,v 1.4 2007/02/09 05:28:22 plh Exp $
#
#------------------------------------------------------------------------------

use pdq;

#------------------------------------------------------------------------------
#
# Based on time_share.c
#
# Illustrates PDQ solver for closed uni-server queue.  Compare with repair.c
#
#------------------------------------------------------------------------------

#---- Model specific variables ------------------------------------------------

#$pop      = 200.0;
$pop      = 100.0;
$think    = 300.0;
$servt    = 0.63;

#---- Initialize the model giving it a name -----------------------------------

pdq::Init("Time Share Computer");
pdq::SetComment("This is just a simple M/M/1 queue.");

#---- Define the workload and circuit type ------------------------------------

$streams = pdq::CreateClosed("compile", $pdq::TERM, $pop, $think);

#  So the value of $streams should correspond to the value of $pdq::streams

#---- Define the queueing center ----------------------------------------------

$nodes  = pdq::CreateNode("CPU", $pdq::CEN, $pdq::FCFS);

#  So the value of $nodes should correspond to the value of $pdq::nodes

#---- Define service demand ---------------------------------------------------

pdq::SetDemand("CPU", "compile", $servt);

#---- Solve the model ---------------------------------------------------------

pdq::Solve($pdq::EXACT);

pdq::Report();

